# merge NH ward data

asc <- function(x) { as.character(x) }

vsysdat <- read.csv("votingsystemsjan08.csv");
dim(vsysdat);
names(vsysdat);
#> dim(vsysdat);
#[1] 237   2
#> names(vsysdat);
#[1] "town" "type"

datp08 <- read.csv("prim08.csv");
dim(datp08);
names(datp08);
#> dim(datp08);
#[1] 333   88
#> names(datp08);
# [1] "county"               "ward"                 "dp08Biden..d"
# [4] "dp08Caligiuri..d"     "dp08Capalbo..d"       "dp08Clinton..d"
# [7] "dp08Cort..r"          "dp08Cox..r"           "dp08Crow..d"
#[10] "dp08D.R..Hunter..d"   "dp08Dodd..d"          "dp08Duncan.Hunter..r"
#[13] "dp08Edwards..d"       "dp08Fendig..Jr...r"   "dp08Gilbert..r"
#[16] "dp08Giuliani..r"      "dp08Gravel..d"        "dp08Hewes..d"
#[19] "dp08Howard..r"        "dp08Huckabee..r"      "dp08Hughes..d"
#[22] "dp08Keefe..d"         "dp08Keyes..r"         "dp08Killeen..d"
#[25] "dp08Klein..r"         "dp08Koos..d"          "dp08Kucinich..d"
#[28] "dp08LaMagna..d"       "dp08Laughlin..d"      "dp08Marchuk..r"
#[31] "dp08McCain..r"        "dp08Mitchell..Jr...r" "dp08O.Connor..r"
#[34] "dp08Obama..d"         "dp08Paul..r"          "dp08Richardson..d"
#[37] "dp08Romney..r"        "dp08Savior..d"        "dp08Scatter"
#[40] "dp08Shepard..r"       "dp08Skok..d"          "dp08Supreme..r"
#[43] "dp08Tancredo..r"      "dp08Thompson..r"      "dp08Wuensche..r"
#[46] "rp08Biden..d"         "rp08Caligiuri..d"     "rp08Capalbo..d"
#[49] "rp08Clinton..d"       "rp08Cort..r"          "rp08Cox..r"
#[52] "rp08Crow..d"          "rp08D.R..Hunter..d"   "rp08Dodd..d"
#[55] "rp08Duncan.Hunter..r" "rp08Edwards..d"       "rp08Fendig..Jr...r"
#[58] "rp08Gilbert..r"       "rp08Giuliani..r"      "rp08Gravel..d"
#[61] "rp08Hewes..d"         "rp08Howard..r"        "rp08Huckabee..r"
#[64] "rp08Hughes..d"        "rp08Keefe..d"         "rp08Keyes..r"
#[67] "rp08Killeen..d"       "rp08Klein..r"         "rp08Koos..d"
#[70] "rp08Kucinich..d"      "rp08LaMagna..d"       "rp08Laughlin..d"
#[73] "rp08Marchuk..r"       "rp08McCain..r"        "rp08Mitchell..Jr...r"
#[76] "rp08O.Connor..r"      "rp08Obama..d"         "rp08Paul..r"
#[79] "rp08Richardson..d"    "rp08Romney..r"        "rp08Savior..d"
#[82] "rp08Scatter"          "rp08Shepard..r"       "rp08Skok..d"
#[85] "rp08Supreme..r"       "rp08Tancredo..r"      "rp08Thompson..r"
#[88] "rp08Wuensche..r"

datp06 <- read.csv("prim06.csv");
dim(datp06);
names(datp06);
#> dim(datp06);
#[1] 333   8
#> names(datp06);
#[1] "county"    "ward"      "dpgov06D"  "dpgov06R"  "dpscatter" "rpgov06R"
#[7] "rpgov06D"  "rpscatter"
names(datp06)[c(5,8)] <- c("dpgov06S","rpgov06S");

datg06 <- read.csv("gen06.csv");
dim(datg06);
names(datg06);
#> dim(datg06);
#[1] 333   5
#> names(datg06);
#[1] "county"  "ward"    "gov06R"  "gov06D"  "scatter"
names(datg06)[5] <- "gov06S";

sum(asc(vsysdat$town) %in% asc(datp08$ward));
sum(!(asc(vsysdat$town) %in% asc(datp08$ward)));
sum(asc(datp08$ward) %in% asc(vsysdat$town));
sum(!(asc(datp08$ward) %in% asc(vsysdat$town)));

vwidx <- asc(vsysdat$town) %in% asc(datp08$ward);
vwloc <- c(outer(asc(vsysdat$town),asc(datp08$ward),"==") %*% 1:length(datp08$ward));

vwards <- rep("",length(datp08$ward));
wvidx <- asc(datp08$ward) %in% asc(vsysdat$town);
wvloc <- c(outer(asc(datp08$ward),asc(vsysdat$town),"==") %*% 1:length(vsysdat$town));
vwards[wvidx] <- asc(vsysdat$type)[wvloc];

Widx <- !wvidx & regexpr(" Ward",asc(datp08$ward))>0;
tW <- gsub(" Ward [0-9]+","",asc(datp08$ward[Widx]));
Wvidx <- tW %in% asc(vsysdat$town);
Wvloc <- c(outer(tW,asc(vsysdat$town),"==") %*% 1:length(vsysdat$town));
vwards[Widx] <- asc(vsysdat$type)[Wvloc];
asc(datp08[vwards=="",2]);
vwards[vwards==""] <- NA;

Nidx <- !wvidx & (regexpr(" Ward",asc(datp08$ward))<0) &
  (regexpr("TOTALS",asc(datp08$ward))<0);
asc(datp08$ward[Nidx]);
tsum <- apply(datp08[Nidx,-(1:2)],1,sum);
names(tsum) <- asc(datp08$ward[Nidx]);
tsum
datp08[Nidx,1:2]

datp08$votesys <- factor(vwards);

cwp08 <- paste(datp08$county, datp08$ward, sep=":");
cwp06 <- paste(datp06$county, datp06$ward, sep=":");
cwg06 <- paste(datg06$county, datg06$ward, sep=":");

length(cwp08);
length(cwp06);
length(cwg06);

all(cwp08 %in% cwp06)
all(cwp06 %in% cwp08)
all(cwp08 %in% cwg06)
all(cwg06 %in% cwp08)

cwp08[!(cwp08 %in% cwg06)]
cwg06[!(cwg06 %in% cwp08)]
cwg06[!(cwg06 %in% cwp08)] <- cwp08[!(cwp08 %in% cwg06)];
all(cwp08 %in% cwg06)
all(cwg06 %in% cwp08)

Tidxp08 <- regexpr("TOTAL", cwp08) > 0;
Tidxp06 <- regexpr("TOTAL", cwp06) > 0;
Tidxg06 <- regexpr("TOTAL", cwg06) > 0;
sum(Tidxp08);
sum(Tidxp06);
sum(Tidxg06);

op08 <- datp08[cwp08 %in% cwp08[!Tidxp08],][order(cwp08[!Tidxp08]),];
op06 <- datp06[cwp06 %in% cwp06[!Tidxp06],][order(cwp06[!Tidxp06]),];
og06 <- datg06[cwg06 %in% cwg06[!Tidxg06],][order(cwg06[!Tidxg06]),];
dim(op08);
dim(op06);
dim(og06);

w0608 <- cbind(op08[,1:2], og06[,-(1:2)], op06[,-(1:2)], op08[,-(1:2)]);
dim(w0608);
names(w0608);

apply(as.matrix(w0608[,-c(1:2,dim(w0608)[2])]), 2, sum);

write.csv(w0608, file="w0608v.csv", row.names=FALSE);
