# work with NH ward data

asc <- function(x) { as.character(x) }

dat <- read.csv("w0608ve.csv");
dim(dat);
names(dat);
#> dim(dat);
#[1] 323  99
#> names(dat);
# [1] "county"               "ward"                 "gov06R"
# [4] "gov06D"               "gov06S"               "dpgov06D"
# [7] "dpgov06R"             "dpgov06S"             "rpgov06R"
#[10] "rpgov06D"             "rpgov06S"             "dp08Biden..d"
#[13] "dp08Caligiuri..d"     "dp08Capalbo..d"       "dp08Clinton..d"
#[16] "dp08Cort..r"          "dp08Cox..r"           "dp08Crow..d"
#[19] "dp08D.R..Hunter..d"   "dp08Dodd..d"          "dp08Duncan.Hunter..r"
#[22] "dp08Edwards..d"       "dp08Fendig..Jr...r"   "dp08Gilbert..r"
#[25] "dp08Giuliani..r"      "dp08Gravel..d"        "dp08Hewes..d"
#[28] "dp08Howard..r"        "dp08Huckabee..r"      "dp08Hughes..d"
#[31] "dp08Keefe..d"         "dp08Keyes..r"         "dp08Killeen..d"
#[34] "dp08Klein..r"         "dp08Koos..d"          "dp08Kucinich..d"
#[37] "dp08LaMagna..d"       "dp08Laughlin..d"      "dp08Marchuk..r"
#[40] "dp08McCain..r"        "dp08Mitchell..Jr...r" "dp08O.Connor..r"
#[43] "dp08Obama..d"         "dp08Paul..r"          "dp08Richardson..d"
#[46] "dp08Romney..r"        "dp08Savior..d"        "dp08Scatter"
#[49] "dp08Shepard..r"       "dp08Skok..d"          "dp08Supreme..r"
#[52] "dp08Tancredo..r"      "dp08Thompson..r"      "dp08Wuensche..r"
#[55] "rp08Biden..d"         "rp08Caligiuri..d"     "rp08Capalbo..d"
#[58] "rp08Clinton..d"       "rp08Cort..r"          "rp08Cox..r"
#[61] "rp08Crow..d"          "rp08D.R..Hunter..d"   "rp08Dodd..d"
#[64] "rp08Duncan.Hunter..r" "rp08Edwards..d"       "rp08Fendig..Jr...r"
#[67] "rp08Gilbert..r"       "rp08Giuliani..r"      "rp08Gravel..d"
#[70] "rp08Hewes..d"         "rp08Howard..r"        "rp08Huckabee..r"
#[73] "rp08Hughes..d"        "rp08Keefe..d"         "rp08Keyes..r"
#[76] "rp08Killeen..d"       "rp08Klein..r"         "rp08Koos..d"
#[79] "rp08Kucinich..d"      "rp08LaMagna..d"       "rp08Laughlin..d"
#[82] "rp08Marchuk..r"       "rp08McCain..r"        "rp08Mitchell..Jr...r"
#[85] "rp08O.Connor..r"      "rp08Obama..d"         "rp08Paul..r"
#[88] "rp08Richardson..d"    "rp08Romney..r"        "rp08Savior..d"
#[91] "rp08Scatter"          "rp08Shepard..r"       "rp08Skok..d"
#[94] "rp08Supreme..r"       "rp08Tancredo..r"      "rp08Thompson..r"
#[97] "rp08Wuensche..r"      "votesys"              "avgwage06"

datdp04 <- read.csv("dp04.csv", sep=";");
dim(datdp04);
names(datdp04);
#> dim(datdp04);
#[1] 323  39
#> names(datdp04);
# [1] "ward"                "dp04Bateman..d"      "dp04MoseleyBraun..d"
# [4] "dp04BraunIII"        "dp04Carter..d"       "dp04Clark..d"
# [7] "dp04Crow..d"         "dp04Dean..d"         "dp04Dokka..d"
#[10] "dp04Edwards..d"      "dp04Gephardt..d"     "dp04Glover..d"
#[13] "dp04Hamm..d"         "dp04Kerry..d"        "dp04Killeen..d"
#[16] "dp04Kucinich..d"     "dp04LaRouche..d"     "dp04Lee..d"
#[19] "dp04Lieberman..d"    "dp04Linnell..d"      "dp04O.Donnell..d"
#[22] "dp04Penna..d"        "dp04Sharpton..d"     "dp04Talbow..d"
#[25] "dp04Ashby..r"        "dp04Bosa..r"         "dp04Buchanan..r"
#[28] "dp04Bush..r"         "dp04Callis..r"       "dp04Gostigian..r"
#[31] "dp04Haines..r"       "dp04harnes..r"       "dp04Howard..r"
#[34] "dp04Laughlin..r"     "dp04O.Connor..r"     "dp04Rigazio..r"
#[37] "dp04Taylor..r"       "dp04Wyatt..r"        "dp04Scatter"

datrp04 <- read.csv("rp04.csv", sep=";");
dim(datrp04);
names(datrp04);
#> dim(datrp04);
#[1] 323  39
#> names(datrp04);
# [1] "ward"                "rp04Ashby..r"        "rp04Bosa..r"
# [4] "rp04Buchanan..r"     "rp04Bush..r"         "rp04Callis..r"
# [7] "rp04Gostigian..r"    "rp04Haines..r"       "rp04Harnes..r"
#[10] "rp04Howard..r"       "rp04Laughlin..r"     "rp04OConnor..r"
#[13] "Rrp04igazio..r"      "rp04Taylor..r"       "rp04Wyatt..r"
#[16] "rp04Bateman..d"      "rp04MoseleyBraun..d" "rp04BraunIII..d"
#[19] "rp04Carter..d"       "rp04Clark..d"        "rp04Crow..d"
#[22] "rp04Dean..d"         "rp04Dokka..d"        "rp04Edwards..d"
#[25] "rp04Gephardt..d"     "rp04Glover..d"       "rp04Hamm..d"
#[28] "rp04Kerry..d"        "rp04Killeen..d"      "rp04Kucinich..d"
#[31] "rp04LaRouche..d"     "rp04Lee..d"          "rp04Lieberman..d"
#[34] "rp04Linnell..d"      "rp04Donnell..d"      "rp04Penna..d"
#[37] "rp04Sharpton..d"     "rp04Talow..d"        "rp04Scatter"
names(datrp04)[13] <- "rp04igazio..r";

NH2004 <- read.csv("NH2004primary_precinct3.csv");
dim(NH2004);
names(NH2004);
#> dim(NH2004);
#[1] 323  63
#> names(NH2004);
# [1] "precinctid"   "precinct"     "munipop"      "pop1990"      "pop2000"
# [6] "pop2002e"     "pop2002g"     "pop2002d"     "fipsname"     "fips"
#[11] "county"       "municipality" "machine"      "bateman"      "braun"
#[16] "braun3"       "carter"       "clark"        "crow"         "dean"
#[21] "dokka"        "edwards"      "gephardt"     "glover"       "hamm"
#[26] "kerry"        "killeen"      "kucinich"     "larouche"     "lee"
#[31] "lieberman"    "linnell"      "odonnell"     "penna"        "sharpton"
#[36] "talbow"       "ashby"        "bosa"         "buchanan"     "bush"
#[41] "callis"       "gostigian"    "haines"       "harnes"       "howard"
#[46] "laughlin"     "oconnor"      "rigazio"      "taylor"       "wyatt"
#[51] "scatter"      "precinct.1"   "muniinc"      "pfim"         "pfimrank"
#[56] "pci"          "pcirank"      "pcidelta"     "pcideltarank" "phim"
#[61] "phimrank"     "povrate"      "povraterank"
names(NH2004)[14:51] <- paste(names(NH2004)[14:51],"04p",sep="");

NH2000 <- read.csv("NH2000primary_precinct.csv");
dim(NH2000);
names(NH2000);
#> dim(NH2000);
#[1] 323  11
#> names(NH2000);
# [1] "precinct"     "precinct2000" "municipality" "county"       "bradley"
# [6] "buckley"      "carter"       "crow"         "eaton"        "gore"
#[11] "mccain"
names(NH2000)[5:11] <- paste(names(NH2000)[5:11],"00p",sep="");

checklist06 <- read.csv("checklist06.csv");
dim(checklist06);
names(checklist06);
#> dim(checklist06)
#[1] 323  11
#> names(checklist06)
# [1] "town"              "ballots.ed06"      "ballots.abs06"
# [4] "ballots.total06"   "checklist.rep06"   "checklist.dem06"
# [7] "checklist.undl06"  "checklist.total06" "ed.reg06"
#[10] "straight.rep06"    "straight.dem06"

NHall <- read.csv("/home/xchg/election/NH2008/nh.replication/data/mysql/NH_all.csv");
dim(NHall);
names(NHall);
#> dim(NHall);
#[1] 234 109
#> names(NHall);
#  [1] "name"                    "name2"
#  [3] "name3"                   "name4"
#  [5] "fips"                    "countyn"
#  [7] "cousub"                  "alpha"
#  [9] "co.name"                 "county.c"
# [11] "tax"                     "eqratio"
# [13] "budget"                  "bus"
# [15] "wastewater"              "commercial"
# [17] "bush04"                  "kerry04"
# [19] "nader04"                 "presscatter04"
# [21] "machine"                 "bush00"
# [23] "gore00"                  "browne00"
# [25] "nader00"                 "phillips00"
# [27] "buchanan00"              "benson04"
# [29] "lynch04"                 "govscatter04"
# [31] "gregg04"                 "haddock04"
# [33] "senscatter04"            "benson02"
# [35] "fernald02"               "babiarz02"
# [37] "govscatter02"            "pci99"
# [39] "totalpop00"              "hisplat00"
# [41] "nonhisplatwhitealone00"  "nonhisplatblackalone00"
# [43] "pmachine"                "nwards"
# [45] "town"                    "edballots04"
# [47] "absballots04"            "totalballots04"
# [49] "repubcheck04"            "demcheck04"
# [51] "undclcheck04"            "totalcheck04"
# [53] "edreg04"                 "edballots02"
# [55] "absballots02"            "totalballots02"
# [57] "repubcheck02"            "demcheck02"
# [59] "undclcheck02"            "totalcheck02"
# [61] "edreg02"                 "edballots00"
# [63] "absballots00"            "totalballots00"
# [65] "repubcheck00"            "demcheck00"
# [67] "undclcheck00"            "totalcheck00"
# [69] "edreg00"                 "repubcheckpri04"
# [71] "demcheckpri04"           "undeclcheckpri04"
# [73] "totalcheckpri04"         "cat1pri04"
# [75] "cat2rpri04"              "cat2dpri04"
# [77] "cat3pri04"               "vote04.total"
# [79] "optical"                 "accuvote"
# [81] "optech"                  "vote04.2pty"
# [83] "vote04.total.gov"        "vote04.total.sen"
# [85] "gov04.2pty"              "sen04.2pty"
# [87] "resvote04"               "pkerry"
# [89] "pgregg04"                "plynch04"
# [91] "pregis04"                "pregis02"
# [93] "pregis00"                "budget10"
# [95] "pci99m"                  "totalpop00m"
# [97] "vote00.total"            "vote00.2pty"
# [99] "pgore00"                 "vote02.total"
#[101] "pfernald02"              "gov02.2pty"
#[103] "wasteyes"                "busyes"
#[105] "pcbudget"                "pvwards"
#[107] "hisplat00p"              "nonhisplatblackalone00p"
#[109] "nonhisplatwhitealone00p"

#a <- paste( tolower(dat$county), tolower(dat$ward))
#b <- paste( tolower(NHall$co.name), tolower(NHall$name))
#
#b[!( b %in% a)]
#a[!( a %in% b)] 

.simpleCap <- function(x) {
  s <- strsplit(x, " ")[[1]]
  paste(toupper(substring(s, 1,1)), substring(s, 2), sep="", collapse=" ")
}

NH2000$county <-
  factor(gsub("Caroll","Carroll",sapply(asc(NH2000$county), .simpleCap)));
NH2004$county <-
  factor(gsub("Caroll","Carroll",sapply(asc(NH2004$county), .simpleCap)));

cwp08 <- paste(dat$county, dat$ward, sep=":");
cwNH04 <- paste(NH2004$county, NH2004$precinct, sep=":");
cwNH00 <- paste(NH2000$county, NH2000$precinct, sep=":");

length(cwp08);
length(cwNH04);
length(cwNH00);

all(cwp08 %in% cwNH00)
all(cwNH00 %in% cwp08)

all(cwp08 %in% cwNH04)
all(cwNH04 %in% cwp08)

cwp08[!(cwp08 %in% cwNH00)];
cwNH00[!(cwNH00 %in% cwp08)];

cwNH00[!(cwNH00 %in% cwp08)] <- cwp08[!(cwp08 %in% cwNH00)];
all(cwp08 %in% cwNH00)
all(cwNH00 %in% cwp08)

all(cwp08==sort(cwNH00))
all(asc(dat$ward) == asc(NH2000$precinct)[order(cwNH00)])
asc(NH2000$precinct)[order(cwNH00)][asc(dat$ward) != asc(NH2000$precinct)[order(cwNH00)]]

all(cwp08==sort(cwNH04))
all(asc(dat$ward) == asc(NH2004$precinct)[order(cwNH04)])

dat <- cbind(dat, NH2000[order(cwNH00),-c(1,3,4)], NH2004[order(cwNH04),-11]);

all(asc(dat$ward) %in% asc(checklist06$town))
all(asc(checklist06$town) %in% asc(dat$ward))

dat <- merge (x=dat,y=checklist06,by.x="ward",by.y="town",all=FALSE,sort=FALSE)

wloc <- grep(" Ward", asc(dat$ward));
w1loc <- grep(" Ward 1$", asc(dat$ward));
wdat <- dat[w1loc,c(1:2,111:115)];
wtab <- table(gsub(" [0-9]+$","",asc(dat$ward)[wloc]));
wtabn <- names(wtab);
wnloc <- sapply(wtabn, function(x){ (1:length(wdat$ward))[regexpr(x, asc(wdat$ward))>0] });
wdatbyw <- wdat;
wdatbyw[,-(1:2)] <-
  (wdat[wnloc,-(1:2)] / wtab)[order(as.numeric(row.names(wdat[wnloc,]))),];
wdat <- dat[wloc,c(1:2,111:115)];
for (i in 1:length(wtabn)) {
  iloc <- grep(wtabn[i],asc(wdat$ward));
  for (j in 3:(dim(wdatbyw)[2])) {
    wdat[iloc,j] <- wdatbyw[grep(wtabn[i], asc(wdatbyw$ward)),j];
  }
}
dat[wloc,c(111:115)] <- wdat[,-(1:2)];

dat <- merge (x=dat,y=datdp04,by="ward",all=FALSE,sort=FALSE)
dat <- merge (x=dat,y=datrp04,by="ward",all=FALSE,sort=FALSE)

NHun <- names(NHall)[!(names(NHall) %in% names(dat))];
wloc <- grep(" Ward", asc(dat$ward));
wname <- gsub(" Ward [0-9]+$","",asc(dat$ward[wloc]));
NHloc <- (1:length(NHall$name))[asc(NHall$name) %in% wname];
NH2dloc <- c(outer(asc(dat$ward),asc(NHall$name),"==") %*% (1:length(NHall$name)));
for (k in NHun) {
  dat[,k] <- NHall[1,k];
}
dat[NH2dloc != 0,NHun] <- NHall[NH2dloc[NH2dloc != 0],NHun];
dat[NH2dloc == 0,NHun] <- NA;
for (i in 1:length(NHloc)) {
  iloc <- NHloc[i];
  iwloc <- grep(asc(NHall$name)[iloc], asc(dat$ward));
  for (j in 1:length(iwloc)) {
    dat[iwloc[j],NHun] <- NHall[NHloc[i],NHun];
  }
}

print(dnames <- names(dat));
#> print(dnames <- names(dat));
#  [1] "ward"                    "county"
#  [3] "gov06R"                  "gov06D"
#  [5] "gov06S"                  "dpgov06D"
#  [7] "dpgov06R"                "dpgov06S"
#  [9] "rpgov06R"                "rpgov06D"
# [11] "rpgov06S"                "dp08Biden..d"
# [13] "dp08Caligiuri..d"        "dp08Capalbo..d"
# [15] "dp08Clinton..d"          "dp08Cort..r"
# [17] "dp08Cox..r"              "dp08Crow..d"
# [19] "dp08D.R..Hunter..d"      "dp08Dodd..d"
# [21] "dp08Duncan.Hunter..r"    "dp08Edwards..d"
# [23] "dp08Fendig..Jr...r"      "dp08Gilbert..r"
# [25] "dp08Giuliani..r"         "dp08Gravel..d"
# [27] "dp08Hewes..d"            "dp08Howard..r"
# [29] "dp08Huckabee..r"         "dp08Hughes..d"
# [31] "dp08Keefe..d"            "dp08Keyes..r"
# [33] "dp08Killeen..d"          "dp08Klein..r"
# [35] "dp08Koos..d"             "dp08Kucinich..d"
# [37] "dp08LaMagna..d"          "dp08Laughlin..d"
# [39] "dp08Marchuk..r"          "dp08McCain..r"
# [41] "dp08Mitchell..Jr...r"    "dp08O.Connor..r"
# [43] "dp08Obama..d"            "dp08Paul..r"
# [45] "dp08Richardson..d"       "dp08Romney..r"
# [47] "dp08Savior..d"           "dp08Scatter"
# [49] "dp08Shepard..r"          "dp08Skok..d"
# [51] "dp08Supreme..r"          "dp08Tancredo..r"
# [53] "dp08Thompson..r"         "dp08Wuensche..r"
# [55] "rp08Biden..d"            "rp08Caligiuri..d"
# [57] "rp08Capalbo..d"          "rp08Clinton..d"
# [59] "rp08Cort..r"             "rp08Cox..r"
# [61] "rp08Crow..d"             "rp08D.R..Hunter..d"
# [63] "rp08Dodd..d"             "rp08Duncan.Hunter..r"
# [65] "rp08Edwards..d"          "rp08Fendig..Jr...r"
# [67] "rp08Gilbert..r"          "rp08Giuliani..r"
# [69] "rp08Gravel..d"           "rp08Hewes..d"
# [71] "rp08Howard..r"           "rp08Huckabee..r"
# [73] "rp08Hughes..d"           "rp08Keefe..d"
# [75] "rp08Keyes..r"            "rp08Killeen..d"
# [77] "rp08Klein..r"            "rp08Koos..d"
# [79] "rp08Kucinich..d"         "rp08LaMagna..d"
# [81] "rp08Laughlin..d"         "rp08Marchuk..r"
# [83] "rp08McCain..r"           "rp08Mitchell..Jr...r"
# [85] "rp08O.Connor..r"         "rp08Obama..d"
# [87] "rp08Paul..r"             "rp08Richardson..d"
# [89] "rp08Romney..r"           "rp08Savior..d"
# [91] "rp08Scatter"             "rp08Shepard..r"
# [93] "rp08Skok..d"             "rp08Supreme..r"
# [95] "rp08Tancredo..r"         "rp08Thompson..r"
# [97] "rp08Wuensche..r"         "votesys"
# [99] "avgwage06"               "precinct2000"
#[101] "bradley00p"              "buckley00p"
#[103] "carter00p"               "crow00p"
#[105] "eaton00p"                "gore00p"
#[107] "mccain00p"               "precinctid"
#[109] "precinct"                "munipop"
#[111] "pop1990"                 "pop2000"
#[113] "pop2002e"                "pop2002g"
#[115] "pop2002d"                "fipsname"
#[117] "fips"                    "municipality"
#[119] "machine"                 "bateman04p"
#[121] "braun04p"                "braun304p"
#[123] "carter04p"               "clark04p"
#[125] "crow04p"                 "dean04p"
#[127] "dokka04p"                "edwards04p"
#[129] "gephardt04p"             "glover04p"
#[131] "hamm04p"                 "kerry04p"
#[133] "killeen04p"              "kucinich04p"
#[135] "larouche04p"             "lee04p"
#[137] "lieberman04p"            "linnell04p"
#[139] "odonnell04p"             "penna04p"
#[141] "sharpton04p"             "talbow04p"
#[143] "ashby04p"                "bosa04p"
#[145] "buchanan04p"             "bush04p"
#[147] "callis04p"               "gostigian04p"
#[149] "haines04p"               "harnes04p"
#[151] "howard04p"               "laughlin04p"
#[153] "oconnor04p"              "rigazio04p"
#[155] "taylor04p"               "wyatt04p"
#[157] "scatter04p"              "precinct.1"
#[159] "muniinc"                 "pfim"
#[161] "pfimrank"                "pci"
#[163] "pcirank"                 "pcidelta"
#[165] "pcideltarank"            "phim"
#[167] "phimrank"                "povrate"
#[169] "povraterank"             "ballots.ed06"
#[171] "ballots.abs06"           "ballots.total06"
#[173] "checklist.rep06"         "checklist.dem06"
#[175] "checklist.undl06"        "checklist.total06"
#[177] "ed.reg06"                "straight.rep06"
#[179] "straight.dem06"          "dp04Bateman..d"
#[181] "dp04MoseleyBraun..d"     "dp04BraunIII"
#[183] "dp04Carter..d"           "dp04Clark..d"
#[185] "dp04Crow..d"             "dp04Dean..d"
#[187] "dp04Dokka..d"            "dp04Edwards..d"
#[189] "dp04Gephardt..d"         "dp04Glover..d"
#[191] "dp04Hamm..d"             "dp04Kerry..d"
#[193] "dp04Killeen..d"          "dp04Kucinich..d"
#[195] "dp04LaRouche..d"         "dp04Lee..d"
#[197] "dp04Lieberman..d"        "dp04Linnell..d"
#[199] "dp04O.Donnell..d"        "dp04Penna..d"
#[201] "dp04Sharpton..d"         "dp04Talbow..d"
#[203] "dp04Ashby..r"            "dp04Bosa..r"
#[205] "dp04Buchanan..r"         "dp04Bush..r"
#[207] "dp04Callis..r"           "dp04Gostigian..r"
#[209] "dp04Haines..r"           "dp04harnes..r"
#[211] "dp04Howard..r"           "dp04Laughlin..r"
#[213] "dp04O.Connor..r"         "dp04Rigazio..r"
#[215] "dp04Taylor..r"           "dp04Wyatt..r"
#[217] "dp04Scatter"             "rp04Ashby..r"
#[219] "rp04Bosa..r"             "rp04Buchanan..r"
#[221] "rp04Bush..r"             "rp04Callis..r"
#[223] "rp04Gostigian..r"        "rp04Haines..r"
#[225] "rp04Harnes..r"           "rp04Howard..r"
#[227] "rp04Laughlin..r"         "rp04OConnor..r"
#[229] "rp04igazio..r"           "rp04Taylor..r"
#[231] "rp04Wyatt..r"            "rp04Bateman..d"
#[233] "rp04MoseleyBraun..d"     "rp04BraunIII..d"
#[235] "rp04Carter..d"           "rp04Clark..d"
#[237] "rp04Crow..d"             "rp04Dean..d"
#[239] "rp04Dokka..d"            "rp04Edwards..d"
#[241] "rp04Gephardt..d"         "rp04Glover..d"
#[243] "rp04Hamm..d"             "rp04Kerry..d"
#[245] "rp04Killeen..d"          "rp04Kucinich..d"
#[247] "rp04LaRouche..d"         "rp04Lee..d"
#[249] "rp04Lieberman..d"        "rp04Linnell..d"
#[251] "rp04Donnell..d"          "rp04Penna..d"
#[253] "rp04Sharpton..d"         "rp04Talow..d"
#[255] "rp04Scatter"             "name"
#[257] "name2"                   "name3"
#[259] "name4"                   "countyn"
#[261] "cousub"                  "alpha"
#[263] "co.name"                 "county.c"
#[265] "tax"                     "eqratio"
#[267] "budget"                  "bus"
#[269] "wastewater"              "commercial"
#[271] "bush04"                  "kerry04"
#[273] "nader04"                 "presscatter04"
#[275] "bush00"                  "gore00"
#[277] "browne00"                "nader00"
#[279] "phillips00"              "buchanan00"
#[281] "benson04"                "lynch04"
#[283] "govscatter04"            "gregg04"
#[285] "haddock04"               "senscatter04"
#[287] "benson02"                "fernald02"
#[289] "babiarz02"               "govscatter02"
#[291] "pci99"                   "totalpop00"
#[293] "hisplat00"               "nonhisplatwhitealone00"
#[295] "nonhisplatblackalone00"  "pmachine"
#[297] "nwards"                  "town"
#[299] "edballots04"             "absballots04"
#[301] "totalballots04"          "repubcheck04"
#[303] "demcheck04"              "undclcheck04"
#[305] "totalcheck04"            "edreg04"
#[307] "edballots02"             "absballots02"
#[309] "totalballots02"          "repubcheck02"
#[311] "demcheck02"              "undclcheck02"
#[313] "totalcheck02"            "edreg02"
#[315] "edballots00"             "absballots00"
#[317] "totalballots00"          "repubcheck00"
#[319] "demcheck00"              "undclcheck00"
#[321] "totalcheck00"            "edreg00"
#[323] "repubcheckpri04"         "demcheckpri04"
#[325] "undeclcheckpri04"        "totalcheckpri04"
#[327] "cat1pri04"               "cat2rpri04"
#[329] "cat2dpri04"              "cat3pri04"
#[331] "vote04.total"            "optical"
#[333] "accuvote"                "optech"
#[335] "vote04.2pty"             "vote04.total.gov"
#[337] "vote04.total.sen"        "gov04.2pty"
#[339] "sen04.2pty"              "resvote04"
#[341] "pkerry"                  "pgregg04"
#[343] "plynch04"                "pregis04"
#[345] "pregis02"                "pregis00"
#[347] "budget10"                "pci99m"
#[349] "totalpop00m"             "vote00.total"
#[351] "vote00.2pty"             "pgore00"
#[353] "vote02.total"            "pfernald02"
#[355] "gov02.2pty"              "wasteyes"
#[357] "busyes"                  "pcbudget"
#[359] "pvwards"                 "hisplat00p"
#[361] "nonhisplatblackalone00p" "nonhisplatwhitealone00p"

write.csv(dat, file="w0008veca2.csv", row.names=FALSE);
