# work with NH ward data

asc <- function(x) { as.character(x) }

dat <- read.csv("w0008veca3.csv");
dim(dat);
names(dat);
#> dim(dat);
#[1] 323 362
#> names(dat);
#  [1] "ward"                    "county"
#  [3] "gov06R"                  "gov06D"
#  [5] "gov06S"                  "dpgov06D"
#  [7] "dpgov06R"                "dpgov06S"
#  [9] "rpgov06R"                "rpgov06D"
# [11] "rpgov06S"                "dp08Biden..d"
# [13] "dp08Caligiuri..d"        "dp08Capalbo..d"
# [15] "dp08Clinton..d"          "dp08Cort..r"
# [17] "dp08Cox..r"              "dp08Crow..d"
# [19] "dp08D.R..Hunter..d"      "dp08Dodd..d"
# [21] "dp08Duncan.Hunter..r"    "dp08Edwards..d"
# [23] "dp08Fendig..Jr...r"      "dp08Gilbert..r"
# [25] "dp08Giuliani..r"         "dp08Gravel..d"
# [27] "dp08Hewes..d"            "dp08Howard..r"
# [29] "dp08Huckabee..r"         "dp08Hughes..d"
# [31] "dp08Keefe..d"            "dp08Keyes..r"
# [33] "dp08Killeen..d"          "dp08Klein..r"
# [35] "dp08Koos..d"             "dp08Kucinich..d"
# [37] "dp08LaMagna..d"          "dp08Laughlin..d"
# [39] "dp08Marchuk..r"          "dp08McCain..r"
# [41] "dp08Mitchell..Jr...r"    "dp08O.Connor..r"
# [43] "dp08Obama..d"            "dp08Paul..r"
# [45] "dp08Richardson..d"       "dp08Romney..r"
# [47] "dp08Savior..d"           "dp08Scatter"
# [49] "dp08Shepard..r"          "dp08Skok..d"
# [51] "dp08Supreme..r"          "dp08Tancredo..r"
# [53] "dp08Thompson..r"         "dp08Wuensche..r"
# [55] "rp08Biden..d"            "rp08Caligiuri..d"
# [57] "rp08Capalbo..d"          "rp08Clinton..d"
# [59] "rp08Cort..r"             "rp08Cox..r"
# [61] "rp08Crow..d"             "rp08D.R..Hunter..d"
# [63] "rp08Dodd..d"             "rp08Duncan.Hunter..r"
# [65] "rp08Edwards..d"          "rp08Fendig..Jr...r"
# [67] "rp08Gilbert..r"          "rp08Giuliani..r"
# [69] "rp08Gravel..d"           "rp08Hewes..d"
# [71] "rp08Howard..r"           "rp08Huckabee..r"
# [73] "rp08Hughes..d"           "rp08Keefe..d"
# [75] "rp08Keyes..r"            "rp08Killeen..d"
# [77] "rp08Klein..r"            "rp08Koos..d"
# [79] "rp08Kucinich..d"         "rp08LaMagna..d"
# [81] "rp08Laughlin..d"         "rp08Marchuk..r"
# [83] "rp08McCain..r"           "rp08Mitchell..Jr...r"
# [85] "rp08O.Connor..r"         "rp08Obama..d"
# [87] "rp08Paul..r"             "rp08Richardson..d"
# [89] "rp08Romney..r"           "rp08Savior..d"
# [91] "rp08Scatter"             "rp08Shepard..r"
# [93] "rp08Skok..d"             "rp08Supreme..r"
# [95] "rp08Tancredo..r"         "rp08Thompson..r"
# [97] "rp08Wuensche..r"         "votesys"
# [99] "avgwage06"               "precinct2000"
#[101] "bradley00p"              "buckley00p"
#[103] "carter00p"               "crow00p"
#[105] "eaton00p"                "gore00p"
#[107] "mccain00p"               "precinctid"
#[109] "precinct"                "munipop"
#[111] "pop1990"                 "pop2000"
#[113] "pop2002e"                "pop2002g"
#[115] "pop2002d"                "fipsname"
#[117] "fips"                    "municipality"
#[119] "machine"                 "bateman04p"
#[121] "braun04p"                "braun304p"
#[123] "carter04p"               "clark04p"
#[125] "crow04p"                 "dean04p"
#[127] "dokka04p"                "edwards04p"
#[129] "gephardt04p"             "glover04p"
#[131] "hamm04p"                 "kerry04p"
#[133] "killeen04p"              "kucinich04p"
#[135] "larouche04p"             "lee04p"
#[137] "lieberman04p"            "linnell04p"
#[139] "odonnell04p"             "penna04p"
#[141] "sharpton04p"             "talbow04p"
#[143] "ashby04p"                "bosa04p"
#[145] "buchanan04p"             "bush04p"
#[147] "callis04p"               "gostigian04p"
#[149] "haines04p"               "harnes04p"
#[151] "howard04p"               "laughlin04p"
#[153] "oconnor04p"              "rigazio04p"
#[155] "taylor04p"               "wyatt04p"
#[157] "scatter04p"              "precinct.1"
#[159] "muniinc"                 "pfim"
#[161] "pfimrank"                "pci"
#[163] "pcirank"                 "pcidelta"
#[165] "pcideltarank"            "phim"
#[167] "phimrank"                "povrate"
#[169] "povraterank"             "ballots.ed06"
#[171] "ballots.abs06"           "ballots.total06"
#[173] "checklist.rep06"         "checklist.dem06"
#[175] "checklist.undl06"        "checklist.total06"
#[177] "ed.reg06"                "straight.rep06"
#[179] "straight.dem06"          "dp04Bateman..d"
#[181] "dp04MoseleyBraun..d"     "dp04BraunIII"
#[183] "dp04Carter..d"           "dp04Clark..d"
#[185] "dp04Crow..d"             "dp04Dean..d"
#[187] "dp04Dokka..d"            "dp04Edwards..d"
#[189] "dp04Gephardt..d"         "dp04Glover..d"
#[191] "dp04Hamm..d"             "dp04Kerry..d"
#[193] "dp04Killeen..d"          "dp04Kucinich..d"
#[195] "dp04LaRouche..d"         "dp04Lee..d"
#[197] "dp04Lieberman..d"        "dp04Linnell..d"
#[199] "dp04O.Donnell..d"        "dp04Penna..d"
#[201] "dp04Sharpton..d"         "dp04Talbow..d"
#[203] "dp04Ashby..r"            "dp04Bosa..r"
#[205] "dp04Buchanan..r"         "dp04Bush..r"
#[207] "dp04Callis..r"           "dp04Gostigian..r"
#[209] "dp04Haines..r"           "dp04harnes..r"
#[211] "dp04Howard..r"           "dp04Laughlin..r"
#[213] "dp04O.Connor..r"         "dp04Rigazio..r"
#[215] "dp04Taylor..r"           "dp04Wyatt..r"
#[217] "dp04Scatter"             "rp04Ashby..r"
#[219] "rp04Bosa..r"             "rp04Buchanan..r"
#[221] "rp04Bush..r"             "rp04Callis..r"
#[223] "rp04Gostigian..r"        "rp04Haines..r"
#[225] "rp04Harnes..r"           "rp04Howard..r"
#[227] "rp04Laughlin..r"         "rp04OConnor..r"
#[229] "rp04igazio..r"           "rp04Taylor..r"
#[231] "rp04Wyatt..r"            "rp04Bateman..d"
#[233] "rp04MoseleyBraun..d"     "rp04BraunIII..d"
#[235] "rp04Carter..d"           "rp04Clark..d"
#[237] "rp04Crow..d"             "rp04Dean..d"
#[239] "rp04Dokka..d"            "rp04Edwards..d"
#[241] "rp04Gephardt..d"         "rp04Glover..d"
#[243] "rp04Hamm..d"             "rp04Kerry..d"
#[245] "rp04Killeen..d"          "rp04Kucinich..d"
#[247] "rp04LaRouche..d"         "rp04Lee..d"
#[249] "rp04Lieberman..d"        "rp04Linnell..d"
#[251] "rp04Donnell..d"          "rp04Penna..d"
#[253] "rp04Sharpton..d"         "rp04Talow..d"
#[255] "rp04Scatter"             "name"
#[257] "name2"                   "name3"
#[259] "name4"                   "countyn"
#[261] "cousub"                  "alpha"
#[263] "co.name"                 "county.c"
#[265] "tax"                     "eqratio"
#[267] "budget"                  "bus"
#[269] "wastewater"              "commercial"
#[271] "bush04"                  "kerry04"
#[273] "nader04"                 "presscatter04"
#[275] "bush00"                  "gore00"
#[277] "browne00"                "nader00"
#[279] "phillips00"              "buchanan00"
#[281] "benson04"                "lynch04"
#[283] "govscatter04"            "gregg04"
#[285] "haddock04"               "senscatter04"
#[287] "benson02"                "fernald02"
#[289] "babiarz02"               "govscatter02"
#[291] "pci99"                   "totalpop00"
#[293] "hisplat00"               "nonhisplatwhitealone00"
#[295] "nonhisplatblackalone00"  "pmachine"
#[297] "nwards"                  "town"
#[299] "edballots04"             "absballots04"
#[301] "totalballots04"          "repubcheck04"
#[303] "demcheck04"              "undclcheck04"
#[305] "totalcheck04"            "edreg04"
#[307] "edballots02"             "absballots02"
#[309] "totalballots02"          "repubcheck02"
#[311] "demcheck02"              "undclcheck02"
#[313] "totalcheck02"            "edreg02"
#[315] "edballots00"             "absballots00"
#[317] "totalballots00"          "repubcheck00"
#[319] "demcheck00"              "undclcheck00"
#[321] "totalcheck00"            "edreg00"
#[323] "repubcheckpri04"         "demcheckpri04"
#[325] "undeclcheckpri04"        "totalcheckpri04"
#[327] "cat1pri04"               "cat2rpri04"
#[329] "cat2dpri04"              "cat3pri04"
#[331] "vote04.total"            "optical"
#[333] "accuvote"                "optech"
#[335] "vote04.2pty"             "vote04.total.gov"
#[337] "vote04.total.sen"        "gov04.2pty"
#[339] "sen04.2pty"              "resvote04"
#[341] "pkerry"                  "pgregg04"
#[343] "plynch04"                "pregis04"
#[345] "pregis02"                "pregis00"
#[347] "budget10"                "pci99m"
#[349] "totalpop00m"             "vote00.total"
#[351] "vote00.2pty"             "pgore00"
#[353] "vote02.total"            "pfernald02"
#[355] "gov02.2pty"              "wasteyes"
#[357] "busyes"                  "pcbudget"
#[359] "pvwards"                 "hisplat00p"
#[361] "nonhisplatblackalone00p" "nonhisplatwhitealone00p"

dnames <- names(dat);

table(dat$votesys, dat$machine);
sum(table(dat$votesys, dat$machine));

zidx <- apply(is.na(as.matrix(dat[,12:97])) | as.matrix(dat[,12:97])==0, 1, all)
zidx06 <- apply(is.na(as.matrix(dat[,3:11])) | as.matrix(dat[,3:11])==0, 1, all)
zidxv08 <- is.na(dat$votesys);
zidxw06 <- is.na(dat$avgwage06);
zidxpov <- is.na(dat$povrate);

dat[zidx | zidx06 | zidxw06 | zidxv08 | zidxpov,1:2];

duse <- dat[!(zidx | zidx06 | zidxw06 | zidxpov),];
dim(duse);

attach(duse);

any(is.na(votesys))

vs10 <- ifelse(asc(votesys)=="H",1,0);
hand04 <- ifelse(machine==0,1,0);
table(vs10,hand04);

dp08dT <- apply(as.matrix(duse[,grep("^dp08[A-Za-z\.]+\.\.d$", dnames)]),1,sum);
dp08rT <- apply(as.matrix(duse[,grep("^dp08[A-Za-z\.]+\.\.r$", dnames)]),1,sum);
rp08dT <- apply(as.matrix(duse[,grep("^rp08[A-Za-z\.]+\.\.d$", dnames)]),1,sum);
rp08rT <- apply(as.matrix(duse[,grep("^rp08[A-Za-z\.]+\.\.r$", dnames)]),1,sum);

gov06T <- gov06D + gov06R + gov06S;
dpgov06T <- dpgov06D + dpgov06R + dpgov06S;
rpgov06T <- rpgov06D + rpgov06R + rpgov06S;
pgov06T <- dpgov06T + rpgov06T;

f06D <- gov06D/gov06T;
f06R <- gov06R/gov06T;

fdp06D <- dpgov06D/dpgov06T;
fdp06R <- dpgov06R/dpgov06T;
frp06D <- rpgov06D/rpgov06T;
frp06R <- rpgov06R/rpgov06T;

fp06D <- (dpgov06D+rpgov06D)/pgov06T;
fp06R <- (dpgov06R+rpgov06R)/pgov06T;

dp04dT <- apply(as.matrix(duse[,grep("^dp04[A-Za-z\.]+\.\.d$", dnames)]),1,sum);
dp04rT <- apply(as.matrix(duse[,grep("^dp04[A-Za-z\.]+\.\.r$", dnames)]),1,sum);
rp04dT <- apply(as.matrix(duse[,grep("^rp04[A-Za-z\.]+\.\.d$", dnames)]),1,sum);
rp04rT <- apply(as.matrix(duse[,grep("^rp04[A-Za-z\.]+\.\.r$", dnames)]),1,sum);

gov06T <- gov06D + gov06R + gov06S;
#cbind(fp06D,fdp06D,dpgov06D,fp06R,frp06R,rpgov06R, avgwage06)

T2000D <- apply(duse[,101:107], 1, sum, na.rm=TRUE);
T2004D <- apply(duse[,120:157], 1, sum, na.rm=TRUE);

pballots.abs06 <- ballots.abs06/ballots.total06;
pchecklist.dem06 <- checklist.dem06/checklist.total06;
pchecklist.undl06 <- checklist.undl06/checklist.total06;

pgore00p <- gore00p/T2000D;
pdean04p <- dean04p/T2004D;
pkerry04p <- kerry04p/T2004D;
pdpgov06T <- dpgov06T/(dpgov06T+rpgov06T);

cbind(pdean04p,pkerry04p,pdpgov06T)[0*30+(1:30),]

wdpgov06T <- (pdpgov06T - pkerry04p) /
  sqrt(pkerry04p *(1-pkerry04p )/T2004D + pdpgov06T*(1-pdpgov06T)/(dpgov06T+rpgov06T));

wddk04p <- (pdean04p - pkerry04p) /
  sqrt(pdean04p *(1-pdean04p )/T2004D + pkerry04p*(1-pkerry04p)/T2004D);

wddean04p <- (pdean04p - pgore00p) /
  sqrt(pdean04p *(1-pdean04p )/T2004D + pgore00p*(1-pgore00p)/T2000D);

wdkerry04p <- (pkerry04p - pgore00p) /
  sqrt(pkerry04p *(1-pkerry04p )/T2004D + pgore00p*(1-pgore00p)/T2000D);

summary(a<-glm( cbind(dean04p,T2004D-dean04p)~1+hand04,family=quasibinomial("logit")))
wpdean04pd <- pdean04p /
  sqrt(summary(a)$dispersion*pdean04p*(1-pdean04p)/T2004D)

summary(a<-glm( cbind(kerry04p,T2004D-kerry04p)~1+hand04,family=quasibinomial("logit")))
wpkerry04pd <- pkerry04p /
  sqrt(summary(a)$dispersion*pkerry04p*(1-pkerry04p)/T2004D)

summary(a<-glm( cbind(gore00p,T2000D-gore00p)~1+hand04,family=quasibinomial("logit")))
wpgore00pd <- pgore00p /
  sqrt(summary(a)$dispersion*pgore00p*(1-pgore00p)/T2000D)

dstdpdiff <- function(v) {
  p <- v/(dp08dT+dp08rT);
  (p - pkerry04p) / sqrt(pkerry04p*(1-pkerry04p)/T2004D + p*(1-p)/(dp08dT+dp08rT));
}

rstdpdiff <- function(v) {
  p <- v/(rp08dT+rp08rT);
  (p - pkerry04p) / sqrt(pkerry04p*(1-pkerry04p)/T2004D + p*(1-p)/(rp08dT+rp08rT));
}

pdp08Clinton..d <- dp08Clinton..d/(dp08dT+dp08rT);
pdp08Edwards..d <- dp08Edwards..d/(dp08dT+dp08rT);
pdp08Kucinich..d <- dp08Kucinich..d/(dp08dT+dp08rT);
pdp08Obama..d <- dp08Obama..d/(dp08dT+dp08rT);
pdp08Richardson..d <- dp08Richardson..d/(dp08dT+dp08rT);
prp08Giuliani..r <- rp08Giuliani..r/(rp08dT+rp08rT);
prp08Huckabee..r <- rp08Huckabee..r/(rp08dT+rp08rT);
prp08McCain..r <- rp08McCain..r/(rp08dT+rp08rT);
prp08Paul..r <- rp08Paul..r/(rp08dT+rp08rT);
prp08Romney..r <- rp08Romney..r/(rp08dT+rp08rT);

wdp08Clinton..d <- dstdpdiff(dp08Clinton..d);
wdp08Edwards..d <- dstdpdiff(dp08Edwards..d);
wdp08Kucinich..d <- dstdpdiff(dp08Kucinich..d);
wdp08Obama..d <- dstdpdiff(dp08Obama..d);
wdp08Richardson..d <- dstdpdiff(dp08Richardson..d);

wrp08Giuliani..r <- rstdpdiff(rp08Giuliani..r);
wrp08Huckabee..r <- rstdpdiff(rp08Huckabee..r);
wrp08McCain..r <- rstdpdiff(rp08McCain..r);
wrp08Paul..r <- rstdpdiff(rp08Paul..r);
wrp08Romney..r <- rstdpdiff(rp08Romney..r);

dtot08all <-
  dp08Biden..d +  dp08Caligiuri..d +  dp08Capalbo..d + 
  dp08Clinton..d +  dp08Crow..d +  dp08D.R..Hunter..d + 
  dp08Dodd..d +  dp08Edwards..d +  dp08Gravel..d + 
  dp08Hewes..d +  dp08Hughes..d +  dp08Keefe..d + 
  dp08Killeen..d +  dp08Koos..d +  dp08Kucinich..d + 
  dp08LaMagna..d +  dp08Laughlin..d +  dp08Obama..d + 
  dp08Richardson..d +  dp08Savior..d +  dp08Scatter + dp08Skok..d;
pdtot08all <- dtot08all/(dp08dT + dp08rT);

dtot04all <-
  dp04Bateman..d +  dp04MoseleyBraun..d +  dp04BraunIII + 
  dp04Carter..d +  dp04Clark..d +  dp04Crow..d +  dp04Dean..d + 
  dp04Dokka..d +  dp04Edwards..d +  dp04Gephardt..d + 
  dp04Glover..d +  dp04Hamm..d +  dp04Kerry..d + 
  dp04Killeen..d +  dp04Kucinich..d +  dp04LaRouche..d + 
  dp04Lee..d +  dp04Lieberman..d +  dp04Linnell..d + 
  dp04O.Donnell..d +  dp04Penna..d +  dp04Sharpton..d + 
  dp04Talbow..d +  dp04Ashby..r +  dp04Bosa..r + 
  dp04Buchanan..r +  dp04Bush..r +  dp04Callis..r + 
  dp04Gostigian..r +  dp04Haines..r +  dp04harnes..r + 
  dp04Howard..r +  dp04Laughlin..r +  dp04O.Connor..r + 
  dp04Rigazio..r +  dp04Taylor..r +  dp04Wyatt..r + dp04Scatter;
pdtot04all <- dtot04all/(dp04dT + dp04rT);

dtot04big <-
  dp04Dean..d + dp04Clark..d + dp04Edwards..d +
  dp04Kerry..d + dp04Lieberman..d;
Pdean04p      <- dp04Dean..d     /dtot04all;
Pclark04p     <- dp04Clark..d    /dtot04all;
Pedwards04p   <- dp04Edwards..d  /dtot04all;
Pkerry04p     <- dp04Kerry..d    /dtot04all;
Plieberman04p <- dp04Lieberman..d/dtot04all;

rdtot08all <-
  rp08Biden..d +  rp08Caligiuri..d +  rp08Capalbo..d + 
  rp08Clinton..d +  rp08Crow..d +  rp08D.R..Hunter..d + 
  rp08Dodd..d +  rp08Edwards..d +  rp08Gravel..d + 
  rp08Hewes..d +  rp08Hughes..d +  rp08Keefe..d + 
  rp08Killeen..d +  rp08Koos..d +  rp08Kucinich..d + 
  rp08LaMagna..d +  rp08Laughlin..d +  rp08Obama..d + 
  rp08Richardson..d +  rp08Savior..d +  rp08Scatter + rp08Skok..d;
prdtot08all <- rdtot08all/(rp08dT + rp08rT);

forRinD04 <- 
  dp04Ashby..r + dp04Bosa..r + dp04Buchanan..r + dp04Bush..r +
  dp04Callis..r + dp04Gostigian..r + dp04Haines..r + dp04harnes..r +
  dp04Howard..r + dp04Laughlin..r + dp04O.Connor..r + dp04Rigazio..r +
  dp04Taylor..r + dp04Wyatt..r;
pforRinD04 <- forRinD04/(dp04dT + dp04rT);

forDinR04 <-
  rp04Bateman..d + rp04MoseleyBraun..d + rp04BraunIII..d + rp04Carter..d +
  rp04Clark..d + rp04Crow..d + rp04Dean..d + rp04Dokka..d +
  rp04Edwards..d + rp04Gephardt..d + rp04Glover..d + rp04Hamm..d +
  rp04Kerry..d + rp04Killeen..d + rp04Kucinich..d + rp04LaRouche..d +
  rp04Lee..d + rp04Lieberman..d + rp04Linnell..d + rp04Donnell..d +
  rp04Penna..d + rp04Sharpton..d + rp04Talow..d;
pforDinR04 <- forDinR04/(rp04dT + rp04rT);

z <- glm( cbind(dp08Obama..d,dp08Clinton..d) ~
         Pdean04p + Pclark04p + Plieberman04p + Pkerry04p + pforRinD04 + pforDinR04 +
         frp06D + fdp06R + I(f06D - f06R) +
         povrate + avgwage06 + votesys,
         family = quasibinomial("logit"))
summary(z)

library(Matching);

## TREATMENT
Tr<- vs10;
## treatement as logical
fTr <- as.logical(Tr)

## match

## GET a propensity for voting system
# wdpgov06T + 
z <- glm( vs10 ~ wpkerry04pd + wdpgov06T + povrate +
         Pdean04p + Pclark04p + Plieberman04p + Pkerry04p + pforRinD04 + pforDinR04 +
         frp06D + fdp06R + I(f06D - f06R) ,
         family="quasibinomial")
summary(z)

## GET p-score
pfit <- as.real(fitted(z))

## matching parms
X <- as.matrix(cbind(
  pfit, wpkerry04pd, wdpgov06T, povrate,
        Pdean04p, Pclark04p, Plieberman04p, Pkerry04p, pforRinD04, pforDinR04,
        frp06D))
## caliper
cal <- rep(1,ncol(X))

## test parms
BM<- as.matrix(cbind(
   wpkerry04pd, wdpgov06T, povrate,
   Pdean04p, Pclark04p, Plieberman04p, Pkerry04p, pforRinD04, pforDinR04,
   pop2002e, pfim, pci, 
   pballots.abs06, pchecklist.undl06, pchecklist.dem06,
   gov06T, dpgov06T, rpgov06T, f06D-f06R, fp06D, fdp06R, frp06D,
   T2004D
));

foo <- "grep best wrk12.2js.Rout | tail -11 | awk '{print $2}'"
sv <- system(foo, intern=TRUE)
sv <- as.real(sv)
foo <- "grep GENERATION: wrk12.2js.Rout | tail -1 | awk '{print $2}'"
generation <- system(foo, intern=TRUE)
generation <- as.real(generation)
cat("Generation", generation," Starting Values:\n")
print(sv)

genout <-
GenMatch(Tr=Tr,X=X, BalanceMatrix=BM, estimand="ATT", M=1,
         pop.size=10, max.generations=1, wait.generations=1,
         starting.values=sv,
         caliper=cal,
         print.level=2)

###

cdata <- cbind(
dp08Clinton..d, (dp08dT+dp08rT),
dp08Obama..d, (dp08dT+dp08rT),
dp08Edwards..d, (dp08dT+dp08rT),
dp08Kucinich..d, (dp08dT+dp08rT),
dp08Richardson..d, (dp08dT+dp08rT),
rp08Giuliani..r, (rp08dT+rp08rT),
rp08Huckabee..r, (rp08dT+rp08rT),
rp08Paul..r, (rp08dT+rp08rT),
rp08Romney..r, (rp08dT+rp08rT),
rp08McCain..r, (rp08dT+rp08rT),
dp08Clinton..d-dp08Obama..d, (dp08dT+dp08rT),
dp08Clinton..d-dp08Edwards..d, (dp08dT+dp08rT),
dp08Obama..d-dp08Edwards..d, (dp08dT+dp08rT),
dp08Clinton..d-dp08Obama..d-dp08Edwards..d, (dp08dT+dp08rT),
rp08Romney..r-rp08McCain..r, (rp08dT+rp08rT) );
dimnames(cdata)[[2]] <-
  c("Clinton","DC","Obama","DO","Edwards","DE","Kucinich","DK","Richardson","DR",
    "Giuliani","RG","Huckabee","RH","Paul","RP","Romney","RR","McCain","RM",
    "C-O","DCO","C-E","DCE","O-E","DOE","C-OE","DCOE","R-M","RRM");

ATTcands <-
 c("Clinton","Obama","Edwards","Kucinich","Richardson",
   "Giuliani","Huckabee","Paul","Romney","McCain");

Y <- dp08Clinton..d;
rr <- Match(Y=Y, Tr=Tr, X=X, estimand="ATT", Weight.matrix=genout,caliper=cal)
print(summary(rr))

ATTarr <- array(NA, dim=c(length(ATTcands), 2, 2));
dimnames(ATTarr) <- list(ATTcands, c("est","SE"), c("counts","prop"));

for (i in 1:length(ATTcands)) {
  Y <- cdata[,(i-1)*2+1];
  rr <- Match(Y=Y, Tr=Tr, X=X, estimand="ATT", Weight.matrix=genout,caliper=cal);
#  print(summary(rr));

  ATTarr[i,,"counts"] <- c(rr$est, rr$se);
}

for (i in 1:length(ATTcands)) {
  Y <- cdata[,(i-1)*2+1]/cdata[,(i-1)*2+2];
  rr <- Match(Y=Y, Tr=Tr, X=X, estimand="ATT", Weight.matrix=genout,caliper=cal);
#  print(summary(rr));

  ATTarr[i,,"prop"] <- c(rr$est, rr$se);
}

ATTarr;

round(ATTarr[,,"counts"],1);
round(ATTarr[,,"prop"],4);
